<template>
  <div v-if="loader" class="loader">
    <p class="text-green-400 text-xl flex align-items-center"><loads-spinner label="Загрузка данных" small/></p>
  </div>
  <div>
    <q-splitter
      v-model="splitterModel"
      style="height: calc(100vh - 70px)"
      class="splitter"
    >
      <template v-slot:before>
        <div class="mx-2 my-2 flex justify-center">
          <q-date
            v-model="dates"
            :events="events"
            :event-color="(el) => new Date(el) < new Date() ? 'red' : 'green'"
            today-btn
            :locale="myLocale"
            color="grey-9"
            class="relative-position"
            @navigation="navigation"
          >
            <q-btn @click="isDoneTask = !isDoneTask" :label="isDoneTask && 'скрыть выполненные' || 'показать выполненные'" size="xs" :color="isDoneTask && 'blue' || 'white'" :text-color="isDoneTask && 'white' || 'black'" class="absolute right-4 top-4"/>
          </q-date>
        </div>
        <UserSelected v-if="roleMiddleware(['ADMIN', 'suHOS', 'HOS'])"
                      :model-select="selectedUser.username"
                      :model-value="selectedUser.username && selectedUser.username || ''"
                      :label-chip="selectedUser.username && selectedUser.username || 'Выбрать пользователя'"
                      color-chip="blue"
                      text-color-chip="white"

                      @selectUser="selectUser"
                      class="block mx-4"

        />
      </template>
      <template v-slot:after>
        <q-tab-panels
            v-model="dates"
            animated
            transition-prev="jump-up"
            transition-next="jump-up"
            class="tab-panel"
        >
          <q-tab-panel :name="dates">
            <q-card v-for="(task, index) in tasks"
                 :key="index"
                 class="flex px-3 py-2 m-2 task-card"
                    :class="{'quickly-task': task.quickly && task.statusTask}"
            >
              <div class="text-h6 flex column">
                <p class="text-sm bg-blue-200 rounded px-2 overflow-hidden truncate w-40 text-center">
                  {{task.phone}}
                  <q-tooltip>{{task.phone}}</q-tooltip>
                </p>
                                {{date.formatDate(task.taskDate, 'DD/MM/YYYY')}} {{task.taskHour}}
                <router-link :to="{name: 'Lead', params: {id: task._id}}" class="mx-auto block w-full">
                  <q-btn size="sm" color="grey-9" push label="Открыть лид" class="w-full"/>
                </router-link>
              </div>
              <q-separator vertical class="mx-6"/>
              <div class="md:w-1/2 w-1/2">
                <div class="my-1" v-html="task.task === 'transfer' && 'Передача' || task.task"></div>
                <div class="my-1" v-html="task.from.username"></div>
                <div class="my-1" v-if="task.message" v-html="task.message"></div>
                <q-chip size="sm"
                        :label="!task.statusTask && 'Выполнено' || 'Не выполнено'"
                        :color="!task.statusTask && 'green' || 'red'"
                        class="text-white"
                />
              </div>
              <q-separator class="mt-2"/>
            </q-card>
            <div v-if="!tasks.length">
              <section class="relative isolate overflow-hidden bg-white px-6 py-24 sm:py-32 lg:px-8">
                <div class="absolute inset-0 -z-10 bg-[radial-gradient(45rem_50rem_at_top,theme(colors.indigo.100),white)] opacity-20"></div>
                <div class="absolute inset-y-0 right-1/2 -z-10 mr-16 w-[200%] origin-bottom-left skew-x-[-30deg] bg-white shadow-xl shadow-indigo-600/10 ring-1 ring-indigo-50 sm:mr-28 lg:mr-0 xl:mr-16 xl:origin-center"></div>
                <div class="mx-auto max-w-2xl lg:max-w-4xl">
                  <img class="mx-auto h-32" src="../../../../crm_avtour_v.2/src/assets/img/icons/tasks.png" alt="">
                  <figure class="mt-10">
                    <blockquote class="text-center text-xl font-semibold leading-8 text-gray-900 sm:text-2xl sm:leading-9">
                      <p>Выберите слева пользователя для просмотра задач или нажмите на кнопку "смотерть все" для просмотра задач нескольких пользователей</p>
                    </blockquote>
                    <figcaption class="mt-10">
                      <div class="mt-4 flex items-center justify-center space-x-3 text-base">
                        <router-link to="/task/users">
                          <q-btn color="primary" label="смотерть все"/>
                        </router-link>
                        <svg viewBox="0 0 2 2" width="3" height="3" aria-hidden="true" class="fill-gray-900">
                          <circle cx="1" cy="1" r="1" />
                        </svg>
                        <router-link to="/" class="text-gray-600">Вернуться на главную</router-link>
                      </div>
                    </figcaption>
                  </figure>
                </div>
              </section>
            </div>
          </q-tab-panel>
        </q-tab-panels>
      </template>
    </q-splitter>
  </div>
</template>

<script>
import {ref, onMounted, onUnmounted, computed, watch} from "vue";
import {useStore} from "vuex";
import { date } from 'quasar'
import api from "../../API/api";
import UserSelected from "../../components/UserSelected.vue";
import LoadsSpinner from "../../components/Loads-spinner.vue";
import {roleMiddleware} from "../../components/roleMiddleware";
export default {
  name: "Task",
  methods: {roleMiddleware},
  components: {LoadsSpinner, UserSelected},
  setup () {
    const store = useStore()
    const user = store.state.user
    const selectedUser = ref({})
    const responseTask = ref([])
    const tasks = ref([])
    const events = ref([])
    const today = date.formatDate(new Date(), 'YYYY/MM/DD')
    const screenWidth = ref(window.innerWidth)
    const isDoneTask = ref(false)
    const loader = ref(false)

    const dates = ref('')
    const parts = dates.value.split("/")
    let year = parseInt(parts[0], 10)
    let month = parseInt(parts[1], 10)
    watch(dates, (val) => {
      getTasks(isDoneTask.value)
    }, { immediate: false })
    watch(isDoneTask, (val) => {
      events.value = []
      getTasks(isDoneTask.value)
    }, { immediate: false })

    const handleResize = () => screenWidth.value = window.innerWidth;
    onMounted(() => dates.value = today);
    onMounted(() => window.addEventListener('resize', handleResize));
    onUnmounted(() => window.removeEventListener('resize', handleResize));

    let user_id = user._id

    async function getTasks(isDoneTask) {
      tasks.value.splice(0, tasks.value.length)
      if (!responseTask.value.length) {
        loader.value = true
        if (!month) {
          const today = new Date();
          year = today.getFullYear();
          month = today.getMonth() + 1; // GetMonth() returns 0-indexed, so add 1
        }
        await api.getTasksLead({_id: user_id, date: dates.value, month, year }).then(res => {
          responseTask.value = res.data.tasks
          loader.value = false
        })
      }
      responseTask.value.filter(elem => {
        const task_id = []
        elem.messages.filter(mess => {
          task_id.push(mess.from?._id === user_id && mess.id)
          if (isDoneTask) {
            if (mess.from?._id === user_id && dates.value === date.formatDate(mess?.taskDate, 'YYYY/MM/DD') && (mess.type === 'Задача' || mess.type === 'transfer')) {
              mess.phone = elem.phone
              mess._id = elem._id
              tasks.value.push(mess)
            }
          } else {
            if (mess.from?._id === user_id && mess?.statusTask && dates.value === date.formatDate(mess?.taskDate, 'YYYY/MM/DD') && (mess.type === 'Задача' || mess.type === 'transfer')) {
              mess.phone = elem.phone
              mess._id = elem._id
              tasks.value.push(mess)
              events.value.push(date.formatDate(mess?.taskDate, 'YYYY/MM/DD'))
            }
          }
        })

        elem.messages.filter(mess => {
          // console.log(item?.taskDate + ' ' + item?.statusTask + ' - ' + item.from.username)
          if (isDoneTask) {
            if (mess.from?._id === user_id && (mess.type === 'Задача' || mess.type === 'transfer')) {
              events.value.push(date.formatDate(mess?.taskDate, 'YYYY/MM/DD'))
            }
          } else {
            if (mess.from?._id === user_id && mess?.statusTask && (mess.type === 'Задача' || mess.type === 'transfer')) {
              events.value.push(date.formatDate(mess?.taskDate, 'YYYY/MM/DD'))
            }
          }
        })
      })
      tasks.value.sort((a, b) => {
        const dateA = new Date(a.taskDate);
        const dateB = new Date(b.taskDate);

        if (dateA < dateB) {
          return -1;
        }
        if (dateA > dateB) {
          return 1;
        }
        return 0;
      });
    }

    async function selectUser (el) {
      responseTask.value.splice(0, responseTask.value.length)
      selectedUser.value = el
      user_id = selectedUser.value._id
      events.value.splice(0, events.value.length)
      await getTasks()
    }
    function navigation (view) {
      year = view.year
      month = view.month
      events.value.splice(0, events.value.length)
      responseTask.value.splice(0, responseTask.value.length)
      getTasks()
    }

    return {
      user,
      selectedUser,
      tasks,
      date,
      screenWidth,
      splitterModel: ref(false),
      dates,
      events,
      isDoneTask,
      loader,
      selectUser,
      navigation,
      currentHour: computed(() => new Date().getTime()),

      myLocale: {
        /* starting with Sunday */
        days: 'Воскресенье_Понедельник_Вторник_Среда_Четверг_Пятница_Суббота'.split('_'),
        daysShort: 'Вс_Пн_Вт_Ср_Чт_Пт_Сб'.split('_'),
        months: 'Январь_Февраль_Март_Апрель_Май_Июнь_Июль_Август_Сентябрь_Октябрь_Ноябрь_Декабрь'.split('_'),
        monthsShort: 'Янв_Фев_Мар_Апр_Май_Июн_Июл_Авг_Сен_Окт_Ноя_Дек'.split('_'),
        firstDayOfWeek: 1, // 0-6, 0 - Sunday, 1 Monday, ...
        format24h: true,
      }
    }
  }
}
</script>
<style lang="scss" scoped>
.quickly-task {
  z-index: 999;
  animation: radial-pulse 1s infinite;
  border-radius: 5px;
}
.loader {
  position: fixed;
  width: 100%;
  height: calc(100% - 90px);
  background-color: rgba(00,00,00,.78);
  backdrop-filter: blur(8px);
  z-index: 2;
  display: flex;
  justify-content: center;
  padding-top: calc(25%);
}
/*создаем анимацию пульсации*/
@keyframes radial-pulse {
  0% {
    box-shadow: 0 0 0 0px rgb(179 27 0 / 50%);
  }
  100% {
    box-shadow: 0 0 0 20px rgb(255 0 0 / 0%);
  }
};
.splitter {
  @media (max-width: 600px) {
    display: grid;
    .q-splitter__separator {
      display: none;
    }
  }
}
.tab-panel {
  grid-template-columns: 1fr 1fr;
}
.task-card {
  &:hover {
    background: #dedede;
  }
}
</style>
